<script lang="ts">
export default {
  name: 'TabControls',
  props: {
    tabData: {
      type: Array,
      required: true,
      default: () => [
        {
          tabName: 'Tab One',
          tabId: 'tabOne', // id used for a11y and query param
        },
        {
          tabName: 'Tab Two',
          tabId: 'tabTwo',
        },
      ],
    },
    selectedTabParam: {
      type: Number,
      required: false,
      default: null,
    },
    currentStep: {
      type: Number,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      selectedTab: this.selectedTabParam !== null ? this.selectedTabParam : 0,
    };
  },
  methods: {
    selectTab(index: number) {
      this.selectedTab = index;
      this.$router.push({
        path: '',
        query: {
          ...this.$route.query,
          step: 1,
          calculator: this.tabData[this.selectedTab].tabId,
        },
      });
    },
  },
};
</script>

<template>
  <div class="tab-wrapper">
    <div role="tablist" class="tablist">
      <button
        v-for="(tab, index) in tabData"
        :id="`${tab.tabId}-tab`"
        :key="`${tab.tabId}-tab`"
        :class="selectedTab === index ? 'active' : ''"
        :aria-selected="selectedTab === index"
        :disabled="selectedTab !== index && currentStep > 0"
        @click="selectTab(index)"
      >
        <SlpTypography tag="span" variant="body1">
          {{ tab.tabName }}
        </SlpTypography>
      </button>
    </div>
    <div
      v-for="(tab, index) in tabData"
      v-show="selectedTab === index"
      :id="`${tab.tabId}-panel`"
      :key="`${tab.tabId}-panel`"
      role="tabpanel"
    >
      <slot :name="index"> </slot>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.tablist {
  display: flex;
  justify-content: center;
  margin-bottom: -1px;

  button {
    color: $color-text-300;
    padding: $spacing-24 0;
    cursor: pointer;
    width: 175px;
    border-top: 3px solid transparent;
    border-left: 1px solid transparent;
    border-right: 1px solid transparent;
    border-bottom: none;

    &:hover:not(disabled),
    :hover:not[disabled] {
      border-top-color: $color-accent-400;

      span {
        font-weight: $font-weight-bold;
      }
    }
    &:disabled,
    &[disabled] {
      opacity: 0.3;
    }

    &.active {
      background-color: $color-surface-50;
      border-top-color: $color-accent-500;
      box-shadow: $color-surface-300 0 45px 32px -1px;
      clip-path: inset(-3px -32px 0px -34px);
      span {
        font-weight: $font-weight-bold;
      }
    }

    @media (max-width: $breakpoint-md) {
      width: 133px;

      span {
        font-size: 16px;
      }
    }
  }
}
</style>
